<template>
  <div class="card-list d-inline-block align-top">
    <card-list-header
      :listName="list.name"
      :numberOfCards="numberOfCards"
      @open-options="openOptions = true"
    ></card-list-header>
    <div class="card-main d-flex flex-column align-items-start">
      <div class="list-of-cards d-flex flex-md-column align-items-center">
        <app-card
          v-for="(card, index) in cards"
          :key="index"
          :card="card"
          @click="handleCardClick(card)"
        />
      </div>
      <card-add-button @click="handleOpenCreateCard" />
    </div>
    <card-create-form
      :list="list"
      :open="openCreateForm"
      @create="handleCreateCard"
      @cancel="handleCloseCreateCard"
      @close="handleCloseCreateCard"
    />
    <card-edit-form
      :card="selectedCard"
      :open="openEditCardForm"
      @edit="handleEditCard"
      @delete="handleDeleteCard"
      @cancel="handleCloseEditCardForm"
      @close="handleCloseEditCardForm"
    />
    <card-list-options
      :id="list.id"
      :open="openOptions"
      @create="handleCreateCard"
      @delete="handleDeleteList"
      @cancel="closeOptions"
      @move-left="handleMoveListLeft"
      @move-right="handleMoveListRight"
    />
  </div>
</template>

<script lang="ts">
import { Card, List, LocalDatabase } from "@/core/database";
import { CardRepository, TodoRepository } from "@/core/repositories";
import { defineComponent, PropType } from "vue";
import CardListHeader from "./CardListHeader.vue";
import AppCard from "./Card.vue";
import CardAddButton from "./CardAddButton.vue";
import CardCreateForm from "./CardCreateForm.vue";
import CardEditForm from "@/components/CardEditForm.vue";
import CardListOptions from "./CardListOptions.vue";
import { ListRepository } from "@/core/repositories/list-repository";
import { SubSink } from "subsink";

export default defineComponent({
  components: {
    CardListHeader,
    AppCard,
    CardAddButton,
    CardCreateForm,
    CardEditForm,
    CardListOptions,
  },
  created() {
    LocalDatabase.getInstance().then(async (db) => {
      this.cardRepository = CardRepository.getInstance(db);
      this.listRepository = ListRepository.getInstance(db);
      this.todoRepository = TodoRepository.getInstance(db);
      const cardObservable = await this.cardRepository.watchAllItems(
        "listId",
        this.list.id
      );
      this.subSink.sink = cardObservable.subscribe((cards) => {
        if (cards) {
          this.cards = cards;
        }
      });
    });
  },
  props: {
    list: {
      type: Object as PropType<List>,
      required: true,
    },
  },
  data() {
    return {
      cardRepository: {} as CardRepository,
      listRepository: {} as ListRepository,
      todoRepository: {} as TodoRepository,
      cards: [] as Card[],
      selectedCard: {} as Card,
      openCreateForm: false,
      openEditCardForm: false,
      openOptions: false,
      subSink: new SubSink(),
    };
  },
  computed: {
    numberOfCards(): number {
      return this.cards.length;
    },
  },
  methods: {
    handleCardClick(card: Card) {
      this.selectedCard = card;
      this.handleOpenEditCardForm();
    },
    async handleCreateCard(newCard: Card) {
      try {
        await this.cardRepository.insertItem(newCard);
      } catch (error) {
        console.log(error);
      }
    },
    handleCloseCreateCard() {
      this.openCreateForm = false;
    },
    handleOpenCreateCard() {
      this.openCreateForm = true;
    },
    async handleEditCard(updatedCard: Card) {
      try {
        await this.cardRepository.updateItem(updatedCard);
      } catch (error) {
        console.log(error);
      }
    },
    handleCloseEditCardForm() {
      this.openEditCardForm = false;
    },
    handleOpenEditCardForm() {
      this.openEditCardForm = true;
    },
    async handleDeleteCard(cardToDelete: Card) {
      try {
        const todos = await this.todoRepository.getAllItems(
          "cardId",
          cardToDelete.id
        );
        if (todos) {
          const promises: Promise<void>[] = [];
          for (let index = 0; index < todos.length; index++) {
            const todo = todos[index];
            promises.push(this.todoRepository.deleteItem(todo));
          }
          await Promise.all(promises);
        }
        await this.cardRepository.deleteItem(cardToDelete);
      } catch (error) {
        console.log(error);
      }
    },
    async handleDeleteList() {
      try {
        const cards = await this.cardRepository.getAllItems(
          "listId",
          this.list.id
        );
        if (cards) {
          const promises: Promise<void>[] = [];
          for (let index = 0; index < cards.length; index++) {
            const card = cards[index];
            promises.push(this.handleDeleteCard(card));
          }
          await Promise.all(promises);
        }
        await this.listRepository.deleteItem(this.list);
      } catch (error) {
        console.log(error);
      }
    },
    handleMoveListLeft() {
      throw new Error("Implement Move List Left");
    },
    handleMoveListRight() {
      throw new Error("Implement Move List Left");
    },
    closeOptions() {
      this.openOptions = false;
    },
  },
  unmounted() {
    this.subSink.unsubscribe();
  },
});
</script>

<style scoped>
.card-list {
  width: 341px;
}

.list-of-cards {
  margin-bottom: 0.625rem;
  overflow-x: auto;
  width: 100vw;
}

.list-of-cards > * {
  margin-right: 0.625rem;
  margin-left: 0.625rem;
}

.list-of-cards > *:first-child {
  margin-left: 0;
}

.list-of-cards > *:last-child {
  margin-right: 0;
}

@media (min-width: 768px) {
  .list-of-cards {
    margin-bottom: 0.625rem;
    overflow-x: auto;
    width: auto;
  }

  .list-of-cards > * {
    margin-right: 0;
    margin-left: 0;
    margin-top: 0.625rem;
    margin-bottom: 0.625rem;
  }

  .list-of-cards > *:first-child {
    margin-top: 0;
  }

  .list-of-cards > *:last-child {
    margin-bottom: 0;
  }
}
</style>
